package be.cylab.java.wowa.training;

import java.lang.reflect.InvocationTargetException;

/**
 * Class to generate objects.
 */
public class Factory {
    private AbstractSolution solution_type;

    /**
     * @param solution_type
     */
    public Factory(final AbstractSolution solution_type) {
        this.solution_type = solution_type;
    }

    /**
     * @return
     */
    public AbstractSolution createSolutionObject(final int a) {
        if (this.solution_type instanceof SolutionDistance) {
            return new SolutionDistance(a);
        } else if (this.solution_type instanceof SolutionAUC) {
            return new SolutionAUC(a);
        } else {
            throw new IllegalArgumentException("Provide o correct type of Solution");
        }
    }
}
